(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)

BeginPackage["Pyros2`EleThermo`", {"Pyros2`", "Pyros2`Utility`", "MSP`"}];

projDir::usage = "";
project::usage = "";
allowedRunMesh::usage = "";
allowedRunSim::usage = "";
allowedRunRes::usage = "";
allowedRunMOR::usage = "";

listmesh::usage = "";

geometryInp::usage = "";
elementInp::usage = "";
materialsTitle::usage = "";
materialsInp::usage = "";
conectivitiesInp::usage = "";

boundaryInp::usage = "";
electricInp::usage = "";
initialInp::usage = "";
simulationInp::usage = "";
solverInp::usage = "";

outCoorTitle::usage = "";
outCoorInp::usage = "";
outContourInp::usage = "";

Begin["`Private`"];

allowedRunMesh = allowedIP1;
allowedRunSim = allowedIP1;
allowedRunRes = allowedIP1;
allowedRunMOR = allowedIP1;

listmesh = {"Mesh of the computational domain", "Mesh of the computational domain"};

project = "EleThermo";
projDir = "EleThermo/tmp/";

geometryInp={
	{"Radius of the simulation domain in m, lchip", "0.000530", "lchip"},
	{"Thickness of wafer in m, tchip", "0.000350", "tchip"},
	{"Radius of chamber at the top in m, lmemb", "0.0002725", "lmemb"},
	{"Radius of chamber at the bottom in m, lbottom", "0.000300", "lbottom"},
	{"Thickness of SiO2 membrane in m, tSiO2m", "1.4*^-6", "tSiO2m"},
	{"Thickness of SiNx membrane in m, tSiNxm", "0.6*^-6", "tSiNxm"},
	{"Inner radius of heater in m, rinheat", "40.*^-6", "rinheat"},
	{"Outher radius of heater in m, roheat", "50.*^-6", "roheat"},
	{"Heater thickness in m, theat", "0.5*^-6", "theat"},
  {"Thickness of SOG protective layer in m, tprotec", "1.0*^-6", "tprotec"}
};

elementInp = {
	{"Element Type: 1 for high-order, 0 for low-oder", "0", "elem"}
};

materialsTitle = {
	"Name", 
	"Density <br> in kg/m^3", 
	"Specific <br> heat capacity <br> in J/(kg K)",
	"Thermal <br> conductivity <br> in W/(m K)",
	"#"
};   

materialsInp = {
	{"Silicon", "2328", "702", "100"},
	{"SiO2", "2270", "1000", "1.4"},
	{"SiNx", "2270", "1000", "49"},
	{"Polisilicon", "3280", "700", "100"},
	{"Fuel", "1526", "1852", "0.25"}
};

(*SOG is not used in the ANSYS script*)
conectivitiesInp = {
	{"Material number for the SiO2 membrane", "2", "SiO2membrane"},
	{"Material number for the SiNx membrane", "3", "SiNxmembrane"},
	{"Material number for the SOG protective layer", "2", "SOG"},
	{"Material number for the heater", "4", "heater"},
	{"Material number for the Si substrate", "1", "substrate"},
	{"Material number for the fuel", "5", "fuel"}
};
  

	
boundaryInp = {
	{"Bottom", "Temp", "0", "0"},
	{"Top", "Heat flow", "0", "0"},
	{"Right side", "Heat flow", "0", "0"}
};

electricInp = {{"Applied electric power in W", "80*^-3", "power"}};

initialInp = {{"Initial device temperature", "0", "Tini"}};

simulationInp = {
	{"Final time for the simulation in s", "1", "finaltime"},
	{"Automatic time stepping: 1 - yes, 0 - no, 2 - logspaced; autostep", "1", "autostep"},
	{"Number of timesteps (if autostep = 0 or 2)", "30", "nstep"},
	{"Initial timestep (if autostep = 1 or 2)", "0.000001", "firststep"},
	{"Minimum timestep (if autostep = 1)", "0.000001", "minstep"},	
	{"Maximum timestep (if autostep = 1)", "0.05", "maxstep"}
};

solverInp = "SPARSE";


outCoorTitle = {
	"Name", 
	"x", 
	"y",
	"z",
	"#"
};   

outCoorInp = {
	{"Node1", "", "", "0"},
	{"Node2", "", "", "0"},
	{"Node3", "", "", "0"},
	{"Node4", "", "", "0"},
	{"Node5", "", "", "0"}
};

outContourInp = {
{"Time in s", "", "time"}
};

End[];
EndPackage[];
