(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)

BeginPackage["Pyros2`EleThermo3D`", {"Pyros2`", "Pyros2`Utility`", "MSP`"}];

projDir::usage = "";
project::usage = "";
allowedRunMesh::usage = "";
allowedRunSim::usage = "";
allowedRunRes::usage = "";
allowedRunMOR::usage = "";

listmesh::usage = "";

geometryInp::usage = "";
elementInp::usage = "";
materialsTitle::usage = "";
materialsInp::usage = "";
conectivitiesInp::usage = "";

boundaryInp::usage = "";
electricInp::usage = "";
initialInp::usage = "";
simulationInp::usage = "";
solverInp::usage = "";

outCoorTitle::usage = "";
outCoorInp::usage = "";
outContourInp::usage = "";

Begin["`Private`"];

allowedRunMesh = allowedIP3;
allowedRunSim = allowedIP3;
allowedRunRes = allowedIP1;
allowedRunMOR = allowedIP3;

listmesh = {"Mesh of the computational domain", "Mesh of the computational domain (half of the model)"};

project = "EleThermo3D";
projDir = "EleThermo3D/tmp/";

geometryInp={
	{"Dimension from the center to the outer simulations edge, lchip", "0.001", "lchip"},
	{"Thickness of the igniter substrate, tchip", "0.000350", "tchip"},
	{"Thickness of tank substrate, ttank", "0.001", "ttank"},
	{"Thickness of seal, tseal", "0.0005", "tseal"},
	{"Thickness of the air gap wafer, tair", "0.00035", "tair"},
	{"Thickness of thermal glue between wafer parts, tglue", "0.0001", "tglue"},
	{"Dimension from the center to the free membrane edge, lmembrane", "0.00075", "lmembrane"},
	{"Thickness of SiO2 layer, tSiO2m", "1.4*^-6", "tSiO2m"},
	{"Thickness of SiNx layer, tSiNxm", "0.6*^-6", "tSiNxm"},
	{"Thickness of heater, theat", "0.5*^-6", "theat"},
	{"Witdh of spiral heater, wheat", "50.*^-6", "wheat"},
	{"Dimension from the center to the edge of heating area, heatarea", "0.000225", "heatarea"}
};

elementInp = {
	{"Element Type: 1 for high-order, 0 for low-oder", "1", "elem"}
};

materialsTitle = {
	"Name", 
	"Density <br> in kg/m^3", 
	"Specific <br> heat capacity <br> in J/(kg K)",
	"Thermal <br> conductivity <br> in W/(m K)",
	"#"
};   

materialsInp = {
	{"Silicon", "2328", "702", "100"},
	{"SiO2", "2270", "1000", "1.4"},
	{"SiNx", "2270", "1000", "49"},
	{"Polisilicon", "3280", "700", "100"},
	{"Fuel", "1526", "1852", "0.25"},
	{"Material2", "2370", "880", "1.35"},
	{"Air", "1.239", "1000", "0.025"},
	{"Glue", "1380", "1000", "1.4"}
};

conectivitiesInp = {
	{"Material number for the SiO2 membrane", "2", "SiO2membrane"},
	{"Material number for the SiNx membrane", "3", "SiNxmembrane"},
	{"Material number for the resistor", "4", "meander"},
	{"Material number for the igniter wafer substrate", "1", "IgniterSubstrate"},
	{"Material number for the igniter fuel", "5", "IgniterFuel"},
	{"Material number for the thermal glue", "8", "ThermalGlue"},
	{"Material number for the chamber fuel", "5", "ChamberFuel"},
	{"Material number for the air gap", "7", "AirGap"},
	{"Material number for the substrate of the air gap wafer", "1", "AirGapSubstrate"},
	{"Material number for the chamber wafer", "6", "ChamberWafer"},
	{"Material number for the seal wafer", "6", "SealWafer"}
};
  

	
boundaryInp = {
	{"Bottom", "Temp", "0", "0"},
	{"Top", "Heat flow", "0", "0"},
	{"Right side", "Heat flow", "0", "0"},
	{"Left side", "Heat flow", "0", "0"},
	{"Front side", "Heat flow", "0", "0"},
	{"Back side", "Heat flow", "0", "0"}
};

electricInp = {{"Applied electric power in W", "150.*^-3", "power"}};

initialInp = {{"Initial device temperature", "0", "Tini"}};

simulationInp = {
	{"Final time for the simulation in s", "1", "finaltime"},
	{"Automatic time stepping: 1 - yes, 0 - no, 2 - logspaced; autostep", "1", "autostep"},
	{"Number of timesteps (if autostep = 0 or 2)", "30", "nstep"},
	{"Initial timestep (if autostep = 1 or 2)", "0.000001", "firststep"},
	{"Minimum timestep (if autostep = 1)", "0.000001", "minstep"},	
	{"Maximum timestep (if autostep = 1)", "0.05", "maxstep"}
};

solverInp = "SPARSE";


outCoorTitle = {
	"Name", 
	"x", 
	"y",
	"z",
	"#"
};   

outCoorInp = {
	{"Node1", "", "", ""},
	{"Node2", "", "", ""},
	{"Node3", "", "", ""},
	{"Node4", "", "", ""},
	{"Node5", "", "", ""}
};

outContourInp = {
{"Rotates working plane around z", "", "theta1"},
{"Rotates working plane around x", "", "theta2"},
{"Rotates working plane around y", "", "theta3"},
{"Moves working plane along x", "", "xoff"},
{"Moves working plane along y", "", "yoff"},
{"Moves working plane along z", "", "zoff"},
{"Time in s", "", "time"}
};

End[];
EndPackage[];
