(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)

BeginPackage["Pyros2`FilmCoef`", {"Pyros2`"}];

FilmCoef::usage = "computational function by itself";
filminp::usage = "input parameters";
filmstring::usage = "just a constant for plots";
filmDir::usage = "directory";

Begin["`Private`"];
<< "FilmCoefEngine.m";

(* display text, default value, name, numerical, variable name *)
(* variable name is needed when numerical = False *)

filminp = {
{"Diameter of the chamber in m" , "0.001", "filmd", True},
{"Velocity in m/s", "10.", "filmv", True},
{"Gas viscosity in kg/(m s)", "1.85*^-5", "filmmu", True},
{"Gas specicif heat capacity in J/(K kg)", "1004.", "filmcp", True},
{"Gas heat conductivity in W/(m K)", "0.0263", "filmkappa", True},
{"Density in kg/m^3", "0.35", "filmro", True}
};

filmstring = Pyros2`addEnd["h/[W/(m^2 K)]"];

filmDir = "FilmCoef/tmp/";
End[];

EndPackage[];
