(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)

BeginPackage["Pyros2`HeatTran`", {"Pyros2`", "Pyros2`Utility`", "MSP`"}];

projDir::usage = "";
project::usage = "";
allowedRunMesh::usage = "";
allowedRunSim::usage = "";
allowedRunRes::usage = "";
allowedRunMOR::usage = "";

listmesh::usage = "";

geometryInp::usage = "";
elementInp::usage = "";
materialsTitle::usage = "";
materialsInp::usage = "";
conectivitiesInp::usage = "";

boundaryInp::usage = "";
electricInp::usage = "";
initialInp::usage = "";
simulationInp::usage = "";
solverInp::usage = "";

outCoorTitle::usage = "";
outCoorInp::usage = "";
outContourInp::usage = "";

Begin["`Private`"];

allowedRunMesh = allowedIP1;
allowedRunSim = allowedIP1;
allowedRunRes = allowedIP1;
allowedRunMOR = allowedIP1;

listmesh = {"Mesh of the computational domain", "Mesh of the computational domain"};

project = "HeatTran";
projDir = "HeatTran/tmp/";

geometryInp={
	{"Radius of the simulation domain in m, lchip", "0.002", "lchip"},
	{"Thickness of wafer in m, tchip", "0.001", "tchip"},
	{"Radius of chamber at the top in m, ltop", "0.0003", "lmemb"},
	{"Radius of chamber at the bottom in m, lbottom", "0.000300", "lbottom"}
};

elementInp = {
	{"Element Type: 1 for high-order, 0 for low-oder", "0", "elem"}
};

materialsTitle = {
	"Name", 
	"Density <br> in kg/m^3", 
	"Specific <br> heat capacity <br> in J/(kg K)",
	"Thermal <br> conductivity <br> in W/(m K)",
	"#"
};   

materialsInp = {
	{"Silicon", "2328", "702", "100"},
	{"SiO2", "2270", "1000", "1.4"},
	{"SiNx", "2270", "1000", "49"},
	{"Polisilicon", "3280", "700", "100"},
	{"Fuel", "1526", "1852", "0.25"}
};

conectivitiesInp = {
	{"Material number for the substrate", "1", "substrate"}
};



boundaryInp = {
	{"Bottom", "Heat flow", "0", "0"},
	{"Top", "Heat flow", "0", "0"},
	{"Right side", "Heat flow", "0", "0"},
	{"Left side", "Convection", "100", "2000"}
};

electricInp = {};

initialInp = {{"Initial device temperature", "0", "Tini"}};

simulationInp = {
	{"Final time for the simulation in s", "1", "finaltime"},
	{"Automatic time stepping: 1 - yes, 0 - no; autostep", "1", "autostep"},
	{"Number of timesteps (if autostep = 0)", "30", "nstep"},
	{"Initial timestep (if autostep = 1)", "0.000001", "firststep"},
	{"Minimum timestep (if autostep = 1)", "0.000001", "minstep"},	
	{"Maximum timestep (if autostep = 1)", "0.05", "maxstep"}
};

solverInp = "SPARSE";


outCoorTitle = {
	"Name", 
	"x", 
	"y",
	"z",
	"#"
};   

outCoorInp = {
	{"Node1", "", "", "0"},
	{"Node2", "", "", "0"},
	{"Node3", "", "", "0"},
	{"Node4", "", "", "0"},
	{"Node5", "", "", "0"}
};

outContourInp = {
{"Time in s", "", "time"}
};

End[];
EndPackage[];
