(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)

BeginPackage["Pyros2`Thrust`", {"Pyros2`"}];

thrust::usage = "computational function";
thrustinp::usage = "input parameters";
thrustDir::usage = "directory";

Begin["`Private`"];
<< "ThrustEngine.m";

(* display text, default value, name, numerical, variable name *)
(* variable name is needed when numerical = False *)

thrustinp = {
{"Radius at throat in m, rThroat" , "0.000054", "thrustrth", True},
{"Cp/Cv ratio, dimensionless" , "1.3", "thrustk", True},
{"R, specific gas constant in J/(kg K)", "435.", "thrustR", True},
{"Flame temperature in K", "2000", "thrustT1", True},
{"External pressure in Pa", "100000.", "thrustpex", True},
{"Area at throat in m^2", "Pi*rThroat^2", "thrustAt", True},
{"Area at oulet in m^2", "Pi*(rThroat + 0.0005*Tan[8/180])^2", "thrustA2", True},
{"The length of the solid fuel chamber in m", "0.002", "thrustl", True},
{"Density of the fuel in kg/m^3", "1500.", "thrustrofuel", True},
{"Initial ratio of empty space in the chamber (can not be zero)", "0.001", "thrustV0", True},
{"Dependence of the area of the burning chamber A(x) in m^2", "Pi*chamberShape[60, 0.0007]^2", "thrustA", False, "x"},
{"Burning rate r(p) in m/s", "7.76*^-5*p^0.29 + 1*^-3", "thrustr", False, "p"}
};

thrustDir = "Thrust/tmp/";
End[];

EndPackage[];

