(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)

BeginPackage["Pyros2`Utility`", {"MSP`", "Pyros2`"}];

(* for all pages 
	startPage.msp set the path and load Pyros2`Utility
	each page starts with startPage and finishes with
	finishPage["action_made"]
*)
startPage::usage = "to initialise debug and info for logging:
Pyros2`tmp`oldMessages, Pyros2`tmp`IP, Pyros2`tmp`nameDebug, Pyros2`tmp`name,
Pyros2`tmp`time, Pyros2`tmp`action";
finishPage::usage = "[action_] string for logging; cleans up everything
and makes logging";

(*general purpose functions *)

getScript::usage = "[file_]; display a given file with pressBack";
getScript2::usage = "[file_]; display a given file";
myMSPToExpression::usage = "";

(* functions for FilmCoef and Thrust *)
makeLoadTable::usage = "[dir_]; Table of sets of saved parametes";
initValues::usage = "[load_, dir_, inp_, context_]; sets Pyros2`tmp`canRun";
(* internal function used by initValues
checkValues::usage = "for simple list 1 - initialize symbols";*)
(* makeTableP1 also for others applications *)
makeTableP1::usage = "[inp_, width_]; for simple list 1";
saveParam::usage = "[IP_, dir_, id_, comment_, list_]; for simple list 1";

(* functions for EleThermo and HeatTran *)
choosePage::usage = "[ID_, btn_]; Dispatcher to run necessary page/function";
(*
	btn == View File -> Return getScript[Symbol["$$file"]]]
	btn == Default Values -> Get *.m files
	ID === "" or btn is not known or "Projects" -> MSPInclude["pyros2/common/Projects"]
		Page calls functions
			makeProjectList
		Page has buttons
			Load Project (in makeProjectList)
			Create New Project
			Default Values
	An external application makes file lock in the ID directory and writes in there the name of the log file. After computation is done the application removes lock file. File refresh.m contains a name of page to display when computation is done.
	ID =!= "" but file lock exists -> MSPInclude["pyros2/common/Lock"]
		Page has buttons
			Refresh (should leave to different outcomes)
	ID =!= "" and no lock file
		btn = Load Project or Main Page
			MSPInclude["pyros2/common/MainPage"] if file.db exists
			otherwise runMesh[ID]
		btn = Create New Project
			make directory and runMesh[ID] if successful
		btn = Refresh
			run a page specified by refresh.m
*)

makeProjectList::usage="[dir_, button_]; make a table with projects";

createProject::usage = "[IP_, allowedIP_, dir_, id_, comment_]. If possible create directory. Name is in utilFullName.";

(*
loadProject::usage = "[ID_, ext_]; Load input.m. Run checkDB.";
checkResult::usage = "[ID_, ext_]; Checks jpg files. First checkDB, then returns OK or noRes";
*)
checkDB::usage = "[ID_, ext_]; check file.ext in the ID. Can return OK(Empty String), noDB, Project does not exist";

showHeader1::usage = "[ID_]; Buttons for projects"; 
showHeader2::usage = "[ID_]; Buttons for subprojects";

(*
runMesh::usage = "[ID_]; check parameters and then either display a form or run Ansys";
checkMeshPar::usage = "";
writeInputMesh::usage = "[ID_]";
runAnsys::usage = "[ID_, filein_, fileout_, type_, list_]";
runSim
checkSimPar
writeInputSim
*)

checkValues1::usage = "for simple list 1 (no symbols - in table) Elethermo and HeatTran";
makeTableP2::usage = "for materials";
checkValues2::usage = "for materials";
makeTableP3::usage = "for boundaries";
checkValues3::usage = "for boundaries";
makeSolver::usage = "";
checkSolver::usage = "";
(* I need checkValues* because of ToExpression at run time *)

checkResPar::usage = "compute new results";
checkNodPar::usage = "compute new results";
makeNodeList::usage = "Table with existing nodes";
makeNodeTable::usage = "Make Node Table for New Resutls";
runResultFile::usage = "regenerate result file";
compareMOR::usage = "";

(*writeOutput::usage = "";*)

checkIfConsistent::usage = "";
showResult::usage = "";

runRes::usage = "";

(* functions for logs *)
generateInfo::usage = "Make a list of OS";
generateLog::usage = "Make a table of logs";

Begin["`Private`"];

myIP = "myIP";

<< "UtilGeneral.m";
<< "UtilThrustFilm.m";
<< "UtilCom.m";
<< "UtilMesh.m";
<< "UtilSim.m";
<< "UtilRes.m";
<< "UtilMOR.m";
<< "UtilNode.m";

(* functions for logs *)

generateInfo := Module[{list, out = "<ul>", dir = "../tmp/"},
	list = FileNames["info*", {dir}, Infinity];
	Scan[
	(
		out = out<>"<li>"<>StringReplace[#, dir->""]<>"</li>\n"
	)&,
	list
	];
	out<>"</ul>"
];

generateLog := Module[{list, out = "<table border=\"1\">", dir = "../tmp/", name},
	list = Select[FileNames["*", {dir}], (FileType[#] == Directory)&];
	list = Map[{#, FileDate[#<>"/log"]}&, list];
	list = Sort[list, OrderedQ[{#1[[2]], #2[[2]]}]&];
	list = Reverse[list];
	out = out<>"<tr><td>Name</td><td>Last Access</td></tr>\n";
	Scan[
	(
		name = StringReplace[#[[1]], dir->""];
		out = out<>"<tr><td>"<>name<>"</td>\n";
		out = out<>"<td>"<>Apply[toTime, #[[2]]]<>"</td>\n";
		If[Pyros2`tmp`IP == myIP,
		out = out<>"<td><form action=\"start\" method=\"post\"><input type=\"hidden\" name=\"file\" value=\""<>name<>"\"><input type=\"Submit\" name=\"btnSubmit\" value=\"View Details\"></form></td>"];
		out = out<>"</tr>\n"
	)&,
	list
	];
	out<>"</table>"
];

End[];
EndPackage[];
