(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)


(* functions for EleThermo and HeatTran *)
choosePage[ID_, btn_] := Module[{err, str},
	If[btn == "View File", Return[getScript[Symbol["$$file"]]]];
	If[btn == "Default Values",
		Pyros2`tmp`action = Pyros2`tmp`action<>"defaultValues;";
		Get["Pyros2`"];
 		Get["Pyros2`Utility`"];
 		Get["Pyros2`"<>Symbol["project"]<>"`"]
	];
	If[ID =!= "",
		If[Length[FileNames[ID<>"/lock"]] === 0,
			Switch[btn,
				x_String /; x == "Load Project" || x == "Main Page",
					Switch[err = loadProject[ID, "db"],
						"",
							MSPInclude["pyros2/common/MainPage"],
						"noDB",
							runMesh[ID],
						_,
							"<p>"<>err<>"</p>"
					],
				"Create New Project",
					Switch[err = createProject[Pyros2`tmp`IP, Symbol["allowedRunMesh"], Symbol["projDir"], ID, Symbol["$$comment"]],
						"",
							runMesh[utilFullName],
						_,
							"<p>"<>err<>"</p>"
					],
				"Refresh",
					str = Get[ID<>"/refresh.m"];
					If[str === $Failed, str = ""];
					Pyros2`tmp`action = Pyros2`tmp`action<>"refresh:"<>StringReplace[ID, Symbol["projDir"]->""]<>":"<>str<>";";
					If[str === "", str = "Projects"];
					MSPInclude["pyros2/common/"<>str],
				"Run Ansys",
					Switch[Symbol["$$type"],
						"mesh",
							runMesh[ID],
						"sim",
							runSim[ID],
						"res",
							runRes[ID],
						_,
							"Internal Error: not known type "<>Symbol["$$type"]<>" for Run Ansys"
					],
				"Add Nodes",
					runAddNodes[ID],
				"Mesh Input",
					Switch[err = loadProject[ID, "db"],
						"",
							Pyros2`tmp`action = Pyros2`tmp`action<>"meshInput:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
							showHeader1[ID]<>checkMeshPar<>"<form>"<>MSPInclude["pyros2/common/InputMesh"]<>"</form>",
						"noDB",
							runMesh[ID],
						_,
							"<p>"<>err<>"</p>"
					],
				"Mesh",
					Switch[err = checkDB[ID, "db"],
						"",
							Pyros2`tmp`action = Pyros2`tmp`action<>"mesh:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
							MSPInclude["pyros2/common/ResultMesh"],
						"noDB",
							runMesh[ID],
						_,
							"<p>"<>err<>"</p>"
					],
				"Nodes",
					Switch[err = checkDB[ID, "db"],
						"",
							Pyros2`tmp`action = Pyros2`tmp`action<>"nodes:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
							MSPInclude["pyros2/common/Nodes"],
						"noDB",
							runMesh[ID],
						_,
							"<p>"<>err<>"</p>"
					],
				"Create New Subproject",
					Switch[err = createProject[Pyros2`tmp`IP, Symbol["allowedRunSim"], Symbol["$$dir"], ID, Symbol["$$comment"]],
						"",
							runSim[utilFullName],
						_,
							"<p>"<>err<>"</p>"
					],
				"Load Subproject",
					Switch[err = loadProject[ID, "rth"],
						"",
							MSPInclude["pyros2/common/Status"],
						"noDB",
							runSim[ID],
						_,
							"<p>"<>err<>"</p>"
					],
				"Status",
					Pyros2`tmp`action = Pyros2`tmp`action<>"status:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
					MSPInclude["pyros2/common/Status"],
				"Input",
					Switch[err = loadProject[ID, "rth"],
						"",
							Pyros2`tmp`action = Pyros2`tmp`action<>"input:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
							showHeader2[ID]<>checkSimPar<>"<form>"<>MSPInclude["pyros2/common/Input"]<>"</form>",
						"noDB",
							runSim[ID],
						_,
							"<p>"<>err<>"</p>"
					],
				"Results",
					Pyros2`tmp`action = Pyros2`tmp`action<>"result:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
					Switch[err = checkResult[ID, "rth"],
						"",
							MSPInclude["pyros2/common/Result"],
						"noDB",
							runSim[ID],
						"noRes",
							MSPInclude["pyros2/common/NewResult"],
						_,
							err
					],
				"New Results",
					Pyros2`tmp`action = Pyros2`tmp`action<>"newResult:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
					Switch[err = checkDB[ID, "rth"],
						"",
							MSPInclude["pyros2/common/NewResult"],
						"noDB",
							runSim[ID],
						_,
							err
					],
				"New Result File",
					runResultFile[ID],
				"Model Reduction",
					Pyros2`tmp`action = Pyros2`tmp`action<>"modred:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
					Switch[err = checkDB[ID, "rth"],
						"",
							MSPInclude["pyros2/common/modred"],
						"noDB",
							runSim[ID],
						_,
							err
					],
				"Run mor4ansys",
					makeMOR[ID],
				"Compare with ANSYS",
					MSPInclude["pyros2/common/modredres"],
				_,
					MSPInclude["pyros2/common/Projects"]
			]
		,
			Pyros2`tmp`action = Pyros2`tmp`action<>"lock:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
			MSPInclude["pyros2/common/Lock"]			
		]
	,
		MSPInclude["pyros2/common/Projects"]
	]
];

makeProjectList[dir_, button_] := Module[{listd, out, com, name},
	Pyros2`tmp`action = Pyros2`tmp`action<>"projectList:"<>StringReplace[dir, Symbol["projDir"]->""]<>";";
	listd = Select[FileNames["*", {dir}], (FileType[#] == Directory)&];
	If[Length[listd] > 0,
	out = "<table border=\"1\"><tr><td>Name</td><td>Comment</td><td>Made by</td></tr>\n";
		Scan[
		(
			com = Get[#1<>"/comment.m"];
			If[com == $Failed, com = ""];
			name = Get[#1<>"/IP.m"];
			If[name == $Failed, name = ""];
			out = out<>"<tr><form action=\"start\" method=\"post\">";
			out = out<>"<td>"<>StringReplace[#1, dir->""]<>"<input type=\"hidden\" name=\"ID\" value=\""<>#1<>"\"></td>";
			out = out<>"<td>"<>com<>"</td>";
			out = out<>"<td>"<>name<>"</td>";
			out = out<>"<td><input type=\"Submit\" name=\"btnSubmit\" value=\""<>button<>"\"></td></form></tr>";
		)&
		,
		listd];
		out<>"</table>"
	,
		"<p>There are no projects yet.</p>"
	]
];

createProject[IP_, allowedIP_, dir_, id_, comment_] := Module[{err, ID},
	Pyros2`tmp`action = Pyros2`tmp`action<>"createProject:"<>id<>";";
	ID = StringReplace[id, dir->""];
	ID = StringReplace[ID, {"."->"", ".."->"", "/"->"", " "->""}];
	If[StringLength[ID] == 0,
		Return["Please enter Name to save data."] 
	];
	utilFullName = ID = dir<>ID;
	If[Length[Select[FileNames[ID], (FileType[#] == Directory)&]] > 0,
		Return["Such Name already exists."]
	];
	If[Length[Select[allowedIP, StringMatchQ[IP, #] &]] == 0,
		Return["You do not have rights to create Name."]
	];
	If[CreateDirectory[ID] === $Failed,
		Return["Unfortunately, it was not possible to create Name."]
	,
		Run["chmod a+rwx "<>ID];
		Put[IPandTime, ID<>"/IP.m"];
	];
	Put[comment, ID<>"/comment.m"];
	""
];

loadProject[ID_, ext_] := Module[{err, err1 = ""},
	If[Get[ID<>"/input.m"] === $Failed, err1 = "noPar"];
	If[(err = checkDB[ID, ext]) === "",
		If[err1 == "noPar", 
			"<p>The project folder "<>ID<>" is inconsistent - no input.m file.</p>"
		,
			""
		]
	,
		err
	]
];

checkResult[ID_, ext_] := Module[{err},
	If[(err = checkDB[ID, ext]) === "",
		If[Length[FileNames["*.jpg", {ID}]] > 0,
			"", "noRes"]
	,
		err
	]
];

checkDB[ID_, ext_] := (
	If[Length[Select[FileNames[ID], (FileType[#] == Directory)&]] > 0,
		If[Length[FileNames["file."<>ext, {ID}]] > 0, "", "noDB"]
	,
		"<p>Project "<>ID<>" does not exist.</p>"
	]
);

showHeader1[ID_] := Module[{out},
	out = "<p><form action=\"start\" method=\"post\">";
	out = out<>"<input type=\"hidden\" name=\"ID\" value=\""<>ID<>"\">";
	out = out<>"<input type=\"Submit\" name=\"btnSubmit\" value=\"Projects\">";
	out = out<>"<input type=\"Submit\" name=\"btnSubmit\" value=\"Main Page\">";
	out = out<>"<input type=\"Submit\" name=\"btnSubmit\" value=\"Mesh Input\">";
	out = out<>"<input type=\"Submit\" name=\"btnSubmit\" value=\"Mesh\">";
	out = out<>"<input type=\"Submit\" name=\"btnSubmit\" value=\"Nodes\">";
	out = out<>"</form></p>";
	out
];

showHeader2[ID_] := Module[{out},
	out = "<table><tr><td><form action=\"start\" method=\"post\">";
	out = out<>"<input type=\"hidden\" name=\"ID\" value=\""<>stripSubproject[ID]<>"\">";
	out = out<>"<input type=\"Submit\" name=\"btnSubmit\" value=\"Main Page\"></form></td>";
	out = out<>"<form action=\"start\" method=\"post\"><input type=\"hidden\" name=\"ID\" value=\""<>ID<>"\">";
	out = out<>"<td><input type=\"Submit\" name=\"btnSubmit\" value=\"Status\"></td>";
	out = out<>"<td><input type=\"Submit\" name=\"btnSubmit\" value=\"Input\"></td>";
	out = out<>"<td><input type=\"Submit\" name=\"btnSubmit\" value=\"Results\"></td>";
	out = out<>"<td><input type=\"Submit\" name=\"btnSubmit\" value=\"New Results\"></td>";
	out = out<>"<td><input type=\"Submit\" name=\"btnSubmit\" value=\"Model Reduction\"></td></form></tr></table>";
	out
];

runAnsys[ID_, filein_, fileout_, type_, list_] := Module[{err, name},
	Run["chmod a+r "<>ID<>"/"<>filein];
	PutAppend[{type, IPandTime}, ID<>"/IP.log"];
	Put[IPandTime, ID<>"/IP."<>type<>".m"];
	If[(err = Run["../bin/runansys.cmd "<>ID<>" "<>filein<>" "<>fileout]) =!= 0,
		"<p>There was an error "<>ToString[err]<>", ANSYS has not been started.</p>"
	,
		i = Length[FileNames["file*.jpg", {ID}]];
		Scan[(
			Put[#<>" made by "<>IPandTime, ID<>"/"<>StringReplace["file000.m", "000"->ToString[NumberForm[i++, 2, NumberPadding -> {"0", "0"}]]]]
			)&
			, 
			list
		];
		MSPInclude["pyros2/common/Lock"]
	]
];

checkVar[var_, put_] := Module[{x},
	If[ToExpression["MSPValueQ[$$"<>var<>"]"],
		If[Symbol["$$"<>var] == "",
			ToExpression[put<>"=$$"<>var];
			"Skip"
		,
			x = ToExpression["myMSPToExpression[$$"<>var<>"]"];
			If[!NumericQ[x],
				"notNum"
			,
				ToExpression[put<>"=$$"<>var];
				x
			]
		]
	,
		ToExpression["$$"<>var<>"="<>put];
		"notRun"
	]
];

checkIfConsistent[ID_] := Module[{nplot, ncap},
	nplot = Length[FileNames["file*.jpg", {ID}]];
	ncap = Length[FileNames["file*.m", {ID}]];
	If[nplot > ncap,
		"<p>There was an internal error: Please, report to developers.</p>"
	,
		If[ncap > nplot,
			i = nplot;
			Do[
				DeleteFile[ID<>"/"<>StringReplace["file000.m", "000"->ToString[NumberForm[i++, 2, NumberPadding -> {"0", "0"}]]]]
			, {ncap - nplot}];
		];
		""
	]

(*	If[Length[FileNames["nonconsistent", {ID}]] == 0,
		nplot = Length[FileNames["file*.jpg", {ID}]];
		ncap = Length[FileNames["file*.m", {ID}]];
		If [nplot =!= ncap, Put["noonconsistent", ID<>"/nonconsistent"]];
	];
	If[Length[FileNames["nonconsistent", {ID}]] > 0,
		"<p>There was an internal error: figures captions may not be correct</p>"
	,
		""
	]
*)
];

