(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)


(* some internal constants and functions *)
utilErr = "";

pressBack = "<p>Press Back in your browser to return to the previous page.</p>";

IPandTime := Pyros2`tmp`name<>" at "<>Pyros2`tmp`time;

toTime[t__] := ToString[StringForm["`3`.`2`.`1` `4`:`5`:`6` CET", t]];

nameTime[IP_] := Module[{ret, str = IP, str2},
	ret = Run["nslookup "<>IP<>" > ../tmp/nslookup"<>IP];
  If[ret === 0,
  	in = OpenRead["../tmp/nslookup"<>IP];
  	str2 = Find[in,"name ="];
  	If[str2 =!= EndOfFile,
  		(*str = StringReplace[str2, "Name:    "->""]*)
  		str = StringDrop[str2, StringPosition[str2, "="][[1,1]] + 1];
  		str = StringDrop[str, -1]
  	];
  	Close[in];
  ];
  DeleteFile["../tmp/nslookup"<>IP];
  {str, Apply[toTime, Date[]]}
];

stripSubproject[ID_] := Module[{str, pos},
	str = StringReplace[ID, Symbol["projDir"]->""];
	pos = StringPosition[str, "/"];
	If[Length[pos] > 0,
		StringDrop[ID, -(StringLength[str] - pos[[1,1]] + 1)]	
	,
		ID
	]
];

(* for all pages *)
startPage := 	(
	Pyros2`tmp`oldMessages = $Messages;
	Pyros2`tmp`IP = $ServletRequest@getRemoteAddr[]; 
	Pyros2`tmp`nameDebug = "../tmp/debug"<>Pyros2`tmp`IP;
	Pyros2`tmp`action = "";
	$Messages = OpenWrite[Pyros2`tmp`nameDebug];
	{Pyros2`tmp`name, Pyros2`tmp`time} = nameTime[Pyros2`tmp`IP]
);	
	
finishPage[action_] := Module[{list},
	Close[$Messages];
	$Messages = Pyros2`tmp`oldMessages;
	If[Pyros2`tmp`IP != myIP,
  	Off[CreateDirectory::"ioerr"];
		CreateDirectory["../tmp/"<>Pyros2`tmp`name];
		On[CreateDirectory::"ioerr"];
		PutAppend[OutputForm[action<>" "<>Pyros2`tmp`time], "../tmp/"<>Pyros2`tmp`name<>"/log"];
	(*$ServletRequest@getHeader["referer"]*)
		Put["", "../tmp/"<>Pyros2`tmp`name<>"/info "<> StringReplace[$ServletRequest@getHeader["user-agent"], {"/"->"_", "(" -> "_", ")" -> "_", ";" -> "_", "[" -> "_", "]" -> "_", ":" -> "_"}]]
	];
	list = Import[Pyros2`tmp`nameDebug, "Text"];
	DeleteFile[Pyros2`tmp`nameDebug];
	ResetDirectory[];
	If[Head[list] === String && StringLength[list] > 0,
		"<hr><code>Debuging info</code><p><pre>"<>list<>"</pre></p>",	""
	]
]

(*general purpose functions *)

getScript[file_] := pressBack<>getScript2[file];

getScript2[file_] := Module[{list, rep = ""},
	If[Length[Names["projDir"]] > 0,
		rep = Symbol["projDir"]];
	Pyros2`tmp`action = Pyros2`tmp`action<>"get:"<>StringReplace[file, rep->""]<>";";
	list = Import[file, "Text"];
	If[Head[list] === String,
		"<hr><p><pre>"<>list<>"</pre></p><hr>"
	,
		"<p>File not found, please contact developer.</p>"
	]
];

myMSPToExpression[x_] := Module[{res}, 
  res = Catch[MSPToExpression[x], MSPException[_String], exception]; 
  If[Head[res] === exception, 
    utilErr = utilErr<>"MSPError: \""<>res[[2, 1]] <>"\" in \""<>res[[1, 2]]<>"\"\n"
	]; 
	res
];


