(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)


runMesh[ID_] := Module[{out},
	Pyros2`tmp`action = Pyros2`tmp`action<>"runMesh:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
	Switch[err = checkDB[ID, "db"],
		"",
			MSPInclude["pyros2/common/MainPage"],
		"noDB",
			out = checkMeshPar;
			If[Length[Select[Symbol["allowedRunMesh"], StringMatchQ[Pyros2`tmp`IP, #] &]] =!= 0,
				If[!Pyros2`tmp`canRun,
					out<>"<form action=\"start\" method=\"post\">\n<p><input type=\"hidden\" name=\"ID\" value=\""<>ID<>"\">\n"<> 
			"<input type=\"hidden\" name=\"type\" value=\"mesh\">\n<input type=\"submit\" name=\"btnSubmit\" value=\"Run Ansys\"></p>\n"<> 
			MSPInclude["pyros2/common/InputMesh"]<>
			"<p><input type=\"submit\" name=\"btnSubmit\" value=\"Run Ansys\"></p></form>"
				,
					writeInputMesh[ID];
					writeGeometry[ID];
					Put["MainPage", ID<>"/refresh.m"];
					runAnsys[ID, "mesh.ans", "mesh.log", "mesh", Symbol["listmesh"]]
				]
			,
				pressBack<>"<p>You are not allowed to run Ansys.</p>"
			],
		_,
			err
	]
];

checkMeshPar := Module[{err = "", err1, ret, cr = True},
	Pyros2`tmp`canRun = False;
	utilErr = "";
	{ret, err1} = ToExpression["checkValues1[geometryInp]"];
	cr = ret && cr;
	err = err<>err1;
	{ret, err1} = ToExpression["checkValues1[elementInp]"];
	cr = ret && cr;
	err = err<>err1;
	{ret, err1} = ToExpression["checkValues2[materialsInp]"];
	cr = ret && cr;
	err = err<>err1;
	{ret, err1} = ToExpression["checkValues1[conectivitiesInp]"];
	cr = ret && cr;
	err = err<>err1;
	Pyros2`tmp`canRun = cr;
	err<>"<p><pre>"<>utilErr<>"</pre></p>"
];



writeInputMesh[dir_] := Module[{},
	Off[DeleteFile::"nffil"];
	DeleteFile[dir<>"/input.m"];
	On[DeleteFile::"nffil"];
	ToExpression["Save[\""<>dir<>"/input.m\", {geometryInp, elementInp, materialsInp, conectivitiesInp}]"];
	of = OpenWrite[dir<>"/mesh.ans", FormatType->OutputForm];
	Write[of, "!This is an automatically generated file"];
	writeInp[of, Symbol["geometryInp"]];
	writeInp[of, Symbol["elementInp"]];
	writematerialsInp[of, Symbol["materialsInp"]];
	writeInp[of, Symbol["conectivitiesInp"]];
	Write[of, "/INPUT,"<>Symbol["project"]<>"Mesh,ans,../../../../ancode"];
	Close[of];
];

writeGeometry[dir_] := Module[{},
	of = OpenWrite[dir<>"/geom.m", FormatType->OutputForm];
	Scan[(
		Write[of, #[[3]]<>"="<>ToString[ToExpression[#[[2]]], InputForm]<>";"] 
	)&, 
	Symbol["geometryInp"]
	];
	Close[of];
];


