(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)

(* Nodes *)

initNodes[ID_] := Module[{in, ic, l1, l2},
	If[Length[FileNames["nodes.txt", {ID}]] > 0,
		in = OpenRead[ID<>"/nodes.txt"];
		ic = OpenRead[ID<>"/coord.txt"];
		l1 = ReadList[in, {Word, Word}];
		l2 = ReadList[ic, {Word, Word, Word}];
		Pyros2`tmp`nodes = MapThread[(Flatten[{#1, #2}])&, {l1, l2}];
		Close[in];
		Close[ic]
	,
		Pyros2`tmp`nodes = {};
	];	
];

makeNodeList[ID_] := Module[{out},
	initNodes[ID];
	out = "<table border=\"1\"><tr><td>Name</td><td>x</td><td>y</td><td>z</td></tr>\n";
	Scan[
		(out = out<>"<tr><td>"<>#[[1]]<>"</td><td>"<>#[[3]]<>"</td><td>"<>#[[4]]<>"</td><td>"<>#[[5]]<>"</td></tr>\n")&
	, Pyros2`tmp`nodes];
	out<>"</table>"
];

checkNodPar := Module[{err = "", ret, list = {}, cr = True, var, i=1, intlist, inc, exist, res},
	Pyros2`tmp`canRun = False;
	utilErr = "";
	Scan[
	(
		intlist = {};
		inc = True;
		var = "$$M"<>ToString[i];
		If[(res = ToExpression["MSPValue["<>var<>"]"]) != "",
			exist = False;
			res = StringReplace[res, " "->""];
			If[StringLength[res] > 8, res = StringTake[res, 8]];
			Scan[
			(If[res == #[[1]], exist = True])&
			, Pyros2`tmp`nodes];
			If[exist,
				inc = False;
				err = err<>res<>" is already exist\n"
			,
				ToExpression[var<>"=\""<>res<>"\""];
				ToExpression["outCoorInp[["<>ToString[i]<>",1]]="<>var]
			]
		,
			cr = False;
			ToExpression[var<>"=\""<>#1[[1]]<>"\""]
		];		
		AppendTo[intlist, Symbol[var]]; 
		ret = checkVar["D"<>ToString[i], "outCoorInp[["<>ToString[i]<>",2]]"];
		Switch[ret,
			"notRun",
				inc = False;
				cr = False,
			"Skip",
				inc = False,
			"notNum",
				inc = False;
				err = err<>"x"<>ToString[i]<>" is not numerical value\n",
			_,
				AppendTo[intlist, ToString[ret, CForm]]
		];
		ret = checkVar["C"<>ToString[i], "outCoorInp[["<>ToString[i]<>",3]]"];
		Switch[ret,
			"notRun",
				inc = False;
				cr = False,
			"Skip",
				inc = False,
			"notNum",
				inc = False;
				err = err<>"y"<>ToString[i]<>" is not numerical value\n",
			_,
				AppendTo[intlist, ToString[ret, CForm]]
		];
		ret = checkVar["K"<>ToString[i], "outCoorInp[["<>ToString[i]<>",4]]"];
		Switch[ret,
			"notRun",
				inc = False;
				cr = False,
			"Skip",
				inc = False,
			"notNum",
				inc = False;
				err = err<>"z"<>ToString[i]<>" is not numerical value\n",
			_,
				AppendTo[intlist, ToString[ret, CForm]]
		];
		If[inc, AppendTo[list, intlist]];
		i++
	)&,
	Symbol["outCoorInp"]
	];
	Pyros2`tmp`canRun = cr;
	Pyros2`tmp`list = list;
	err<>utilErr
];

runAddNodes[ID_] := Module[{err},
	Pyros2`tmp`action = Pyros2`tmp`action<>"runNodes:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
	Get[ID<>"/geom.m"];
	err = checkNodPar;
	If[Length[Select[Symbol["allowedRunRes"], StringMatchQ[Pyros2`tmp`IP, #] &]] =!= 0,
		If[(!Pyros2`tmp`canRun) || (err != ""),
			MSPInclude["pyros2/common/Nodes"]
		,
			If[Length[Pyros2`tmp`list] > 0,
				writeNodeOutput[ID];
				Put["Nodes", ID<>"/refresh.m"];
				runAnsys[ID, "nodes.ans", "nodes.log", "nod", {}]
			,
				pressBack<>"<p>Nothing to compute, press Back in your Browser and fill values.</p>"			
			]
		]
	,
		pressBack<>"<p>You are not allowed to run Ansys.</p>"
	]
];

writeNodeOutput[dir_] := Module[{of, i},
	of = OpenWrite[dir<>"/nodes.ans", FormatType->OutputForm];
	Write[of, "!This is an automatically generated file"];
	Write[of, "RESUME, file, db"];
	Write[of, "ALLSELE"];
	Write[of, ""];
	Write[of, "*CFOPEN, nodes, txt, , APPEND"];
	i = 1;
	Scan[(
		Write[of, "n" <> ToString[i] <> " = NODE(" <> #[[2]] <> "," <> #[[3]] <> "," <> #[[4]] <> ")"];
		Write[of, "*VWRITE,'"<>#[[1]]<>"',n"<>ToString[i++]];
		Write[of, "(A20, F10.0)"] 
	)&,
	Pyros2`tmp`list];
	Write[of, "*CFCLOS"];
	Write[of, ""];
	Write[of, "*CFOPEN, coord, txt, , APPEND"];
	i = 1;
	Scan[(
		Write[of, "x = NX(n" <> ToString[i] <> ")"];
		Write[of, "y = NY(n" <> ToString[i] <> ")"];
		Write[of, "z = NZ(n" <> ToString[i++] <> ")"];
		Write[of, "*VWRITE,x,y,z"];
		Write[of, "(3G15.5)"] 
	)&,
	Pyros2`tmp`list];
	Write[of, "*CFCLOS"];
	Write[of, ""];	
	Write[of, "/EXIT, NOSAVE"];
	Close[of]
];


