(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)

(* res *)

checkResPar := Module[{err = "", ret, list2 = {}, cr = True, i},
	Pyros2`tmp`canRun = False;
	utilErr = "";
	i = 1;
	Scan[(
		ret = checkVar[#[[3]], "outContourInp[["<>ToString[i]<>",2]]"];
		Switch[ret,
			"notRun",
				cr = False,
			"Skip",
				Null,
			"notNum",
				err = err<>#[[3]]<>" is not numerical value\n",
			_,
				AppendTo[list2, ToString[ret, CForm]]
		];
		i++
	)&,
	Symbol["outContourInp"]
	];
	Pyros2`tmp`canRun = cr;
	Pyros2`tmp`list2 = list2;
	err<>utilErr
];

makeNodeTable := Module[{out = "<table border=\"1\">\n", v, j},
	Do[
		v = "N"<>ToString[i];
		out = out<>"<td><select name=\""<>v<>"\">\n";
		out = out<>"<option selected>None</option>\n";
		j = 1;
		Scan[
			(out = out<>"<option value=\""<>ToString[j++]<>"\">"<>#[[1]]<>"</option>\n")&
		, Pyros2`tmp`nodes];
		out = out<>"</select></td></tr>\n";
	,
		{i, 5}
	];
	out<>"</table>"
];

writeOutput[dir_] := Module[{res, of, str, str2, i, li, node, inc},
	res = {};
	of = OpenWrite[dir<>"/res.ans", FormatType->OutputForm];
	Write[of, "!This is an automatically generated file"];
	Write[of, "RESUME, file, db, .."];
	Write[of, "ALLSELE"];
	Write[of, "/SHOW,JPEG"];
	Write[of, "JPEG,ORIENT,HORIZ"];
	Write[of, "/GFILE,300,"];
	Write[of, "/RGB,INDEX,100,100,100,0"];
	Write[of, "/RGB,INDEX,0,0,0,15"];
		Write[of, ""];
		Write[of, "/POST26"];
		str = "Temperature as a function of time at ";
		str2 = "";
		i = 2;
		li = Pyros2`tmp`nodes;
		inc = False;
		Do[
			If[(node = ToExpression["$$N"<>ToString[ii]]) != "None",
				inc = True;
				node = ToExpression[node];
				str = str<>li[[node, 1]]<>"("<>li[[node, 3]]<>","<>li[[node, 4]]<>","<>li[[node, 5]]<>") ";
				str2 = str2<>","<>ToString[i];
				Write[of, "NSOL," <> ToString[i++] <> ","<>li[[node,2]]<>",TEMP,," <> li[[node, 1]]]
			] 
		, {ii, 5}];
		If[inc, 
			res = Append[res, str];
			Write[of, "/AXLAB,X,Time / s"];
			Write[of, "/AXLAB,Y,Temperature / C"];
			Write[of, "/WIND,ALL,OFF"];
			Write[of, "/WIND,1,FULL"];
			Write[of, "PLVAR"<>str2];
			Write[of, "FINISH"];
			Write[of, ""];
		];
	li = Pyros2`tmp`list2;
	If[Length[li] == Length[Symbol["outContourInp"]],
		If[Length[li] == 1,
			Write[of, "/POST1"];
			Write[of, "SET, , ,1, ,"<>li[[1]]];
			Write[of, "/EFACE,1"];
			Write[of, "/WIND,ALL,OFF"];
			Write[of, "/WIND,1,FULL"];
			Write[of, "PLNSOL,TEMP, ,0,"];
			Write[of, "FINISH"];
			Write[of, ""];
			res = Append[res, "Contour plot at "<>Pyros2`tmp`list2[[1]]<>" s"]
		,
			Write[of, "/POST1"];
			Write[of, "SET, , ,1, ,"<>li[[7]]];
			Write[of, "/EFACE,1"];
(*			Write[of, "WPLANE,-1,0,0,0"];*)
			Write[of, "WPSTYL,DEFA"];
			Write[of, "WPROTA,"<>li[[1]]<>","<>li[[2]]<>","<>li[[3]]];
			Write[of, "WPOFFS,"<>li[[4]]<>","<>li[[5]]<>","<>li[[6]]];
			Write[of, "/WIND,ALL,OFF"];
			Write[of, "/WIND,1,TOP"];
			Write[of, "/WIND,2,BOT"];
			Write[of, "/VIEW,1,1,2,3"];
			Write[of, "/TYPE,1,8"];
			Write[of, "/CPLANE,1"];
			Write[of, "/VIEW,2,WP"];
			Write[of, "/TYPE,2,1"];
			Write[of, "PLNSOL,TEMP, ,0,"];
			Write[of, "FINISH"];
			Write[of, ""];
			res = Append[res, "Contour plot at "<>Pyros2`tmp`list2[[7]]<>" s, theta1="<>li[[1]]<>", theta2="<>li[[2]]<>", theta3="<>li[[3]]<>", xoff="<>li[[4]]<>", yoff="<>li[[5]]<>", zoff="<>li[[6]] ]			
		]
	];
	Write[of, "/EXIT, NOSAVE"];
	Close[of];
	res
];

runRes[ID_] := Module[{res, err},
	Pyros2`tmp`action = Pyros2`tmp`action<>"runRes:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
	Get[ID<>"/../geom.m"];
	err = checkResPar;
	If[Length[Select[Symbol["allowedRunRes"], StringMatchQ[Pyros2`tmp`IP, #] &]] =!= 0,
		If[(!Pyros2`tmp`canRun) || (err != ""),
			MSPInclude["pyros2/common/NewResult"]
		,
			res = writeOutput[ID];
			If[Length[res] > 0,
				Put["Result", ID<>"/refresh.m"];
				runAnsys[ID, "res.ans", "res.log", "res", res]
			,
				pressBack<>"<p>Nothing to compute, press Back in your Browser and fill values.</p>"			
			]
		]
	,
		pressBack<>"<p>You are not allowed to run Ansys.</p>"
	]
];

showResult[ID_] := Module[{list, out = "", com},
	list = FileNames["file*.jpg", {ID}];
	Scan[(
		out = out <> "<p><img src=\""<>StringReplace[#, Symbol["projDir"]->"tmp/"]<>"\" alt=\""<>#<>"\"></p>";
		com = Get[StringReplace[#, "jpg"->"m"]];
		If[Head[com] =!= String, com = ""];
		out = out <>"<p>"<> com <>"</p>\n"
	)&, 
	list];
	out
];

