(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)

(* sim *)

runSim[ID_] := Module[{out},
	Pyros2`tmp`action = Pyros2`tmp`action<>"runSim:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
	Switch[err = checkDB[ID, "rth"],
		"",
			MSPInclude["pyros2/common/Result"],
		"noDB",
			out = checkSimPar;
			If[Length[Select[Symbol["allowedRunSim"], StringMatchQ[Pyros2`tmp`IP, #] &]] =!= 0,
				If[!Pyros2`tmp`canRun,
					out<>"<form action=\"start\" method=\"post\">\n<p><input type=\"hidden\" name=\"ID\" value=\""<>ID<>"\">\n"<> 
			"<input type=\"hidden\" name=\"type\" value=\"sim\">\n<input type=\"submit\" name=\"btnSubmit\" value=\"Run Ansys\"></p>\n"<> 
			MSPInclude["pyros2/common/Input"]<>
			"<p><input type=\"submit\" name=\"btnSubmit\" value=\"Run Ansys\"></p></form>"
				,
					writeInputSim[ID];
					Put["Status", ID<>"/refresh.m"];
					runAnsys[ID, "sim.ans", "sim.log", "sim", {}]
				]
			,
				pressBack<>"<p>You are not allowed to run Ansys.</p>"
			],
		_,
			err
	]
];

checkSimPar := Module[{err = "", err1, ret, cr = True},
	Pyros2`tmp`canRun = False;
	utilErr = "";
	{ret, err1} = ToExpression["checkValues3[boundaryInp]"];
	cr = ret && cr;
	err = err<>err1;
	{ret, err1} = ToExpression["checkValues1[electricInp]"];
	cr = ret && cr;
	err = err<>err1;
	{ret, err1} = ToExpression["checkValues1[initialInp]"];
	cr = ret && cr;
	err = err<>err1;
	{ret, err1} = ToExpression["checkValues1[simulationInp]"];
	cr = ret && cr;
	err = err<>err1;
	{ret, err1} = ToExpression["checkSolver[solverInp]"];
	cr = ret && cr;
	err = err<>err1;
	Pyros2`tmp`canRun = cr;
	err<>"<p><pre>"<>utilErr<>"</pre></p>"
];

checkValues1[list_] := Module[{err, x, canRun = True, i = 1},
	err = "";
	Scan[
	(
		If[ToExpression["MSPValue[$$"<>#1[[3]]<>"]"] != "",
			x = ToExpression["myMSPToExpression[$$"<>#1[[3]]<>"]"];
			If[!NumericQ[x],
				err = err<>#1[[1]]<>" is not a numerical value\n"
			,
				list[[i, 2]] = ToExpression["$$"<>#1[[3]]];
			]
		,
			canRun = False;
			ToExpression["$$"<>#1[[3]]<>"=\""<>#1[[2]]<>"\""]
		];
		++i;		
	)&,
	list
	];
	If[StringLength[err] > 0, 
		canRun = False;
		err = "<p><code>There were errors, please correct</code><pre>" <>err<>"</pre></p>"
	];
	{canRun, err} 
];
SetAttributes[checkValues1, HoldFirst];

makeTableP2[header_, list_] := Module[{out = "<table border=\"1\">\n", nm},
	nm = {"M", "D", "C", "K"};
	out = out<>"<tr>";
	Scan[
	(
		out = out<>"<td>"<>#<>"</td>\n";
	)&
	,
		header
	];
	out = out<>"</tr>";
	Do[
		out = out<>"<tr>";
		Scan[
		(
			out = out<>"<td><input type=\"text\" name=\""<>#<>ToString[i]<>"\" size=\"15\" value =\""<> ToExpression["$$"<>#<>ToString[i]]<>"\"></td>\n";
		)&
		,
			nm
		];
		out = out<>"<td>"<>ToString[i]<>"</td></tr>";
	,
		{i, Length[list]}
	];
	out<>"</table>"
];

checkValues2[list_] := Module[{x, var, err, canRun = True, i = 1},
	err = "";
	Scan[
	(
		var = "$$M"<>ToString[i];
		If[ToExpression["MSPValue["<>var<>"]"] != "",
			list[[i, 1]] = ToExpression[var]
		,
			canRun = False;
			ToExpression[var<>"=\""<>#1[[1]]<>"\""]
		];		
		var = "$$D"<>ToString[i];	
		If[ToExpression["MSPValue["<>var<>"]"] != "",
			x = ToExpression["myMSPToExpression["<>var<>"]"];
			If[!NumericQ[x],
				err = err<>"Density #"<>ToString[i]<>" is not a numerical value\n"
			,
				list[[i, 2]] = ToExpression[var]
			]
		,
			canRun = False;
			ToExpression[var<>"=\""<>#1[[2]]<>"\""]
		];				
		var = "$$C"<>ToString[i];	
		If[ToExpression["MSPValue["<>var<>"]"] != "",
			x = ToExpression[ "myMSPToExpression["<>var<>"]"];
			If[!NumericQ[x],
				err = err<>"Head capacity #"<>ToString[i]<>" is not a numerical value\n"
			,
				list[[i, 3]] = ToExpression[var]
			]
		,
			canRun = False;
			ToExpression[var<>"=\""<>#1[[3]]<>"\""]
		];				
		var = "$$K"<>ToString[i];	
		If[ToExpression["MSPValue["<>var<>"]"] != "",
			x = ToExpression["myMSPToExpression["<>var<>"]"];
			If[!NumericQ[x],
				err = err<>"Heat conductivity #"<>ToString[i]<>" is not a numerical value\n"
			,
				list[[i, 4]] = ToExpression[var]
			]
		,
			canRun = False;
			ToExpression[var<>"=\""<>#1[[4]]<>"\""]
		];				
		i++
	)&,
	list
	];
	If[StringLength[err] > 0, 
		canRun = False;
		err = "<p><code>There were errors, please correct</code><pre>" <>err<>"</pre></p>"
	];
	{canRun, err} 
];
SetAttributes[checkValues2, HoldFirst];

ifSelected[str_, par_] := If[str === par, "selected", ""];

makeTableP3[list_] := Module[{out = "<table border=\"1\">\n", v},
	Do[
		out = out<>"<tr><td>"<>list[[i, 1]]<>"</td>\n";
		v = ToExpression["$$B"<>ToString[i]];
		out = out<>"<td><select name=\"B"<>ToString[i]<>"\">\n";
		out = out<>"<option "<>ifSelected["Heat flow", v] <>">Heat flow</option>\n";
		out = out<>"<option "<> ifSelected["Temp", v] <>">Temp</option>\n";
		out = out<>"<option "<> ifSelected["Convection", v] <>">Convection</option>\n";
		out = out<>"</select></td>\n";
		out = out<>"<td><input type=\"text\" name=\"B"<>ToString[i]<>"1\" size=\"15\" value =\""<> ToExpression["$$B"<>ToString[i]<>"1"]<>"\"></td>\n";
		out = out<>"<td><input type=\"text\" name=\"B"<>ToString[i]<>"2\" size=\"15\" value =\""<> ToExpression["$$B"<>ToString[i]<>"2"]<>"\"></td></tr>\n";	
	,
		{i, Length[list]}
	];
	out<>"</table>"
];

checkValues3[list_] := Module[{x, var, err, canRun = True, i = 1},
	err = "";
	Scan[
	(
		var = "$$B"<>ToString[i];
		If[ToExpression["MSPValue["<>var<>"]"] != "",
				list[[i, 2]] = ToExpression[var]
		,
			canRun = False;
			ToExpression[var<>"=\""<>#1[[2]]<>"\""]
		];		
		var = "$$B"<>ToString[i]<>"1";	
		If[ToExpression["MSPValue["<>var<>"]"] != "",
			x = ToExpression["myMSPToExpression["<>var<>"]"];
			If[!NumericQ[x],
				err = err<>"First boundary value #"<>ToString[i]<>" is not a numerical value\n"
			,
				list[[i, 3]] = ToExpression[var]
			]
		,
			canRun = False;
			ToExpression[var<>"=\""<>#1[[3]]<>"\""]
		];				
		var = "$$B"<>ToString[i]<>"2";	
		If[ToExpression["MSPValue["<>var<>"]"] != "",
			x = ToExpression["myMSPToExpression["<>var<>"]"];
			If[!NumericQ[x],
				err = err<>"Second boundary value #"<>ToString[i]<>" is not a numerical value\n"
			,
				list[[i, 4]] = ToExpression[var]
			]
		,
			canRun = False;
			ToExpression[var<>"=\""<>#1[[4]]<>"\""]
		];						
		i++
	)&,
	list
	];
	If[StringLength[err] > 0, 
		canRun = False;
		err = "<p><code>There were errors, please correct</code><pre>" <>err<>"</pre></p>"
	];
	{canRun, err} 
];
SetAttributes[checkValues3, HoldFirst];

makeSolver[v_] := Module[{out = ""},
	out = out<>"<select name=\"solver\">\n";
	out = out<>"<option "<> ifSelected["FRONT", v] <>">FRONT</option>\n";
	out = out<>"<option "<> ifSelected["SPARSE", v] <>">SPARSE</option>\n";
	out = out<>"<option "<> ifSelected["JCG", v] <>">JCG</option>\n";
	out = out<>"<option "<> ifSelected["JCGOUT", v] <>">JCGOUT</option>\n";
	out = out<>"<option "<> ifSelected["ICCG", v] <>">ICCG</option>\n";
	out = out<>"<option "<> ifSelected["PCG", v] <>">PCG</option>\n";
	out = out<>"<option "<> ifSelected["PCGOUT", v] <>">PCGOUT</option>\n";
	out = out<>"<option "<> ifSelected["ITER", v] <>">ITER</option>\n";
	out = out<>"</select>\n";
	out
];

checkSolver[v_] := Module[{canRun = True},
	If[ToExpression["MSPValue[$$solver]"] != "",
		v = ToExpression["$$solver"]
	,
		canRun = False;
		ToExpression["$$solver=\""<>v<>"\""]
	];
	{canRun, ""}
];
SetAttributes[checkSolver, HoldFirst];

writeInp[of_, inp_] := (Write[of, "!"];
	Scan[(
		Write[of, "!"<>#[[1]]];
		Write[of, #[[3]]<>"="<>ToString[ToExpression[#[[2]]], CForm]] 
)&, inp]);

writematerialsInp[of_, inp_] := Module[{i},
	Write[of, "!"];
	i = 1;
	Scan[(
		Write[of, "!"<>#[[1]]];
		Write[of, "D"<>ToString[i]<>"="<>ToString[ToExpression[#[[2]]], CForm]];
		Write[of, "C"<>ToString[i]<>"="<>ToString[ToExpression[#[[3]]], CForm]];
		Write[of, "K"<>ToString[i]<>"="<>ToString[ToExpression[#[[4]]], CForm]];
		i++;
	)&, inp]	
];

writeboundaryInp[of_, inp_] := Module[{i},
	Write[of, "!"];
	i = 1;
	Scan[(
		Write[of, "!"<>#[[1]]];
		Switch[#[[2]],
			"Heat flow",
				If[ToExpression[#[[3]]] == 0,
					Write[of, "B"<>ToString[i]<>"=0"]
				,
					Write[of, "B"<>ToString[i]<>"=1"]
				],
			"Temp",
				Write[of, "B"<>ToString[i]<>"=2"],
			"Convection",
				Write[of, "B"<>ToString[i]<>"=3"],
			_,
				Print["Error in elewritematerialsInp: ", #[[2]]]
		];
		Write[of, "B"<>ToString[i]<>"1="<>ToString[ToExpression[#[[3]]], CForm]];
		Write[of, "B"<>ToString[i]<>"2="<>ToString[ToExpression[#[[4]]], CForm]];
		i++;
	)&, inp]	
];

writeInputSim[dir_] := Module[{},
	Off[DeleteFile::"nffil"];
	DeleteFile[dir<>"/input.m"];
	On[DeleteFile::"nffil"];
	ToExpression["Save[\""<>dir<>"/input.m\", {boundaryInp, electricInp, initialInp, simulationInp, solverInp}]"];
	of = OpenWrite[dir<>"/BC.ans", FormatType->OutputForm];
	Write[of, "!This is an automatically generated file"];
	Write[of, "resume, file, db, .."];
	writeboundaryInp[of, Symbol["boundaryInp"]];
	writeInp[of, Symbol["electricInp"]];
	Write[of, "/INPUT,"<>Symbol["project"]<>"BC,ans,../../../../../ancode"];
	Close[of];
	of = OpenWrite[dir<>"/sim.ans", FormatType->OutputForm];
	Write[of, "!This is an automatically generated file"];
	Write[of, "/INPUT, BC,ans"];
	writeInp[of, Symbol["initialInp"]];
	writeInp[of, Symbol["simulationInp"]];
	Write[of, "solver='"<>Symbol["solverInp"]<>"'"];
	Write[of, "/INPUT, TimeSim,ans,../../../../../ancode"];
	Write[of, "/EXIT, NOSAVE"];
	Close[of];
];

writeResultOutput[ID_] := Module[{n, li},
	n = Get[ID<>"/nstep.txt"];
	initNodes[ID<>"/.."];
	li = Pyros2`tmp`nodes;
	of = OpenWrite[ID<>"/out.ans", FormatType->OutputForm];
	Write[of, "!This is an automatically generated file"];
	If [Length[li] == 0, 	Write[of, "/EXIT, NOSAVE"]; Close[of]; Return[]];
	Write[of, "resume, file, db, .."];
	Write[of, "/post26"];
	Write[of, "NSOL,2,"<>li[[1,2]]<>",TEMP"];
	Write[of, "*dim,arr,array,"<>ToString[n]];
	Write[of, "vget,arr,1"];
	Write[of, "*CFOPEN, results, txt"];
	Write[of, "*VWRITE,"<>ToString[n]];
	Write[of, "(F10.0)"];
	Write[of, "*VWRITE,arr(1)"];
	Write[of, "(G15.5)"];
	Scan[
	(
		Write[of, "NSOL,2,"<>#[[2]]<>",TEMP"];
		Write[of, "vget,arr,2"];
		Write[of, "*VWRITE,'"<>#[[1]]<>"'"];
		Write[of, "(A15)"];
		Write[of, "*VWRITE,arr(1)"];
		Write[of, "(G15.5)"];
	)&
	,li];
	Write[of, "*CFCLOS"];
	Write[of, "/EXIT, NOSAVE"];
	Close[of];

];

runResultFile[ID_] := Module[{err},
	Pyros2`tmp`action = Pyros2`tmp`action<>"runResultFile:"<>StringReplace[ID, Symbol["projDir"]->""]<>";";
	If[Length[Select[Symbol["allowedRunRes"], StringMatchQ[Pyros2`tmp`IP, #] &]] =!= 0,
		writeResultOutput[ID];
		Put["modred", ID<>"/refresh.m"];
		runAnsys[ID, "out.ans", "out.log", "out", {}]
	,
		pressBack<>"<p>You are not allowed to run Ansys.</p>"
	]
];

