(*
Copyright (C) 2003-2004 Evgenii Rudnyi, http://Evgenii.Rudnyi.Ru

This software is a copyrighted work licensed under the terms, described
in the file "FREE_LICENSE". 
*)

(* functions for FilmCoef and Thrust *)

makeLoadTable[dir_] := Module[{listd, out, com, name},
	listd = Select[FileNames["*", {dir}], (FileType[#] == Directory)&];
	If[Length[listd] > 0,
		out = "<table border=\"1\">";
		out = out<>"<tr><td>Name<br>Click to choose</td>";
		out = out<>"<td>Comment</td>";
		out = out<>"<td>Saved by</td></tr>\n";
		Scan[
		(
			com = Get[#1<>"/comment.m"];
			If[com == $Failed, com = ""];
			name = Get[#1<>"/IP.m"];
			If[name == $Failed, name = ""];
			out = out<>"<tr><td><input type=\"Submit\" name=\"load\" value=\""<>StringReplace[#1, dir->""]<>"\"></td>";
			out = out<>"<td>"<>com<>"</td>";
			out = out<>"<td>"<>name<>"</td></tr>\n";
		)&
		,
		listd];
		out<>"</table>\n"
	,
		"<p>There are no saved sets of parameters.</p>"
	]
];

initValues[load_, dir_, inp_, context_] := Module[{err1, err2, par},
	Pyros2`tmp`canRun = False;
	err1 = "";
	err2 = "";
	If[load != "",
		par = True; 
		Pyros2`tmp`action = Pyros2`tmp`action<>":load:"<>load<>";";
		If[Get[dir<>load<>"/param.m"] === $Failed,
			err1 = "<p>Parameters could not be loaded.</p>"
		,
			err1 = "<p>Parameters have been loaded.</p>"
		]
	];
	{Pyros2`tmp`canRun, err2} = checkValues[inp, context];
	If[par, Pyros2`tmp`canRun = False];
	err1<>err2
]

checkValues[list_, context_] := Module[{err, x, canRun = True},
	err = "";
	Scan[
	(
		If[ToExpression["MSPValue[$$"<>#1[[3]]<>"]"] != "",
			If[#1[[4]],
				x = ToExpression[context<>#1[[3]]<> "=MSPToExpression["<>"$$"<>#1[[3]]<>"]"];
				If[!NumericQ[x],
					err = err<>#1[[1]]<>" is not a numerical value.\n"]
			,
				x = ToExpression[context<>#1[[3]]<> "=(Evaluate[MSPToExpression["<>"$$"<>#1[[3]]<>"]/."<>#1[[5]]<>"->#])&"];
				If[!NumericQ[x[0]],
					err = err<>#1[[1]]<>" at 0 is not a numerical value.\n"]
			]
		,
			canRun = False;
			ToExpression["$$"<>#1[[3]]<>"=\""<>#1[[2]]<>"\""]
		]			
	)&,
	list
	];
	If[StringLength[err] > 0, 
		canRun = False;
		err = "<p><code>There were errors, please correct.</code><pre>" <>err<>"</pre></p>"
	];
	{canRun, err} 
];

makeTableP1[list_, width_] := Module[{out = "<table border=\"1\">\n"},
	Scan[
	(
		out = out<>"<tr><td>"<>#[[1]]<>" :</td><td><input type=\"text\"
		name=\""<>#[[3]]<>"\" size=\""<>width<>"\" value =\""<>ToExpression["$$"<>#[[3]]]<>"\"></td></tr>\n";
	)&
	,
		list
	];
	out<>"</table>\n"
];

saveParam[IP_, dir_, id_, comment_, list_] := 
	Module[{err, ID},
	Pyros2`tmp`action = Pyros2`tmp`action<>":save:"<>id<>";";
	err = createProject[IP, allowedIP1, dir, id, comment];
	If[err =!= "", Return[err]];
	ID = utilFullName;
	Scan[
	(
		ToExpression["Save[\""<>ID<>"/param.m\","<>"$$"<>#1[[3]]<>"]"]
	)&
	,
	list
	];
	"Parameters have been saved."
];

